PROC DisplayErrorBox()
   SHOWDIALOG "* * ERROR * * ERROR * *"
      @ 5, 10
      HEIGHT 12
      WIDTH 60
      
      @ 1, 0 ?? FORMAT ("W58,AC", "YOU HAVE PRESSED AN INVALID KEY")
      @ 3, 0 ?? FORMAT ("W58,AC", "This Area is not Available at this time")
      @ 5, 0 ?? FORMAT ("W58,AC", "PRESS OK Button to return to sale")
      
      PUSHBUTTON @ 8, 23
         WIDTH 12
         "~O~K"
         OK
         VALUE "OKButtonPressed"
         TAG "OKButton"
      TO OKButton
   ENDDIALOG
ENDPROC

PROC EnterNewSale()
   COEDIT "POS"
   WINDOW MOVE GETWINDOW() TO -100, -100
   PICKFORM "F"
   WINDOW HANDLE CURRENT TO PosWindow
      
   DYNARRAY WindowAttributes["HEIGHT"]    = 21
   DYNARRAY WindowAttributes["ORIGINROW"] = 1
   DYNARRAY WindowAttributes["ORIGINCOL"] = 0
   DYNARRAY WindowAttributes["CANMOVE"]   = True
   DYNARRAY WindowAttributes["CANRESIZE"] = True
   DYNARRAY WindowAttributes["CANCLOSE"]  = False
   
   WINDOW SETATTRIBUTES PosWindow FROM WindowAttributes
   
   PROMPT "[F2] Close | [F10] Menu | [Ctrl-T] To End Sale
   WAIT WORKSPACE
      PROC "ProcessWaitEvents"
      MESSAGE "MENUSELECT"
   ENDWAIT
   
   PROMPT ""
   DO_IT!
   CLEARALL
   
      ECHO NORMAL
      ECHO OFF
ENDPROC

PROC ProcessWaitEvents(TriggerType, EventInfo, CycleNumber)
   SWITCH
      CASE (EventInfo["TYPE"] = "KEY") :
         SWITCH
            CASE (EventInfo["KEYCODE"] = -83) :
            DisplayDeleteBox()
            RETURN 1
            
            CASE (EventInfo[KEYCODE"] = -60)  :
               IF (ISFIELDVIEW() = True)
                  THEN RETURN 0
               ENDIF
               IF (ISVALID() <> True)
                  THEN RETURN 0
               ENDIF
               IF (SYSMODE() = "Main")
                  THEN RETURN 2
               ENDIF
               ECHO NORMAL
               Do_It!
               RETURN 1
            CASE (EventInfo["KEYCODE"] = 20  :
               CalculateSaleTotal()
               RETURN 1
            OTHERWISE:
               SOUND 400 100
               RETURN 1
   ENDSWITCH
CASE (EventInfo["MESSAGE"] = "MENUSELECT")  :
   SWITCH
      
      CASE (EventInfo["MENUTAG"] = "Inventory") :
         DisplayErrorBox()
         RETURN 0
      
      CASE (EventInfo["MENUTAG"] = "Members") :
         DisplayErrorBox()
         RETURN 0
      
      CASE (EventInfo["MENUTAG"] = "Pos")  :
         IF (ISFIELDVIEW() = True)

            THEN Do_It!
         ENDIF
         Do_It!
         IF (SYSMODE() = "Main")
            THEN RETURN 2
         ENDIF
         ECHO NORMAL
         Do_It!
         RETURN 1
      OTHERWISE:
         SOUND 400 100
         RETURN 1
   ENDSWITCH
ENDPROC           
      
PROC DisplayDeleteBox()
   SHOWDIALOG "Delete Item"
      @ 6, 10
      HEIGHT 7
      WIDTH 54
      @ 1,4 ?? "ARE YOU SURE YOU WANT TO DELETE THIS ITEM?"
      
      PUSHBUTTON @ 3, 30 WIDTH 12
         "~C~ancel"
         CANCEL
         VALUE "CancelButton"
         TAG "Cancel"
      TO CancelButton
      
      PUSHBUTTON @ 3, 11 WIDTH 12
        "~O~K"
        OK
        VALUE "OK"
        TAG "OKButton"
     TO OKButton
  ENDDIALOG
  IF (RetVal = True)
     THEN ECHO NORMAL
         Del
  ENDIF
ENDPROC               

PROC CalculateSaleTotal()
   
   MOVETO "Pos"            
     SCAN
       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False))     
          THEN [LINETOTAL] = ([PRICE]*[QTY_SOLD])
       ENDIF
       IF (ISBLANK([DISC%]) = True)
          THEN [DISC$] = 0
       IF (ISBLANK([DISC%]) = False)
          THEN [DISC$] = ([PRICE]*[QTY_SOLD])-(([PRICE]*[QTY_SOLD])*[DISC%])
       ENDIF
       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False))
             THEN [TAX] = (([LINETOTAL]-[DISC$])*.0775)
       ENDIF
       [TOTAL] = ([LINETOTAL]-[DISC$])+[TAX]

       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False AND
           (ISBLANK([TRANS_NO]) = True))     
             THEN [TRANS_NO] = CMAX(Sales, TRANS_NO) + 1
       ENDIF
       
       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False AND
           (ISBLANK([SALE_DATE]) = True))
              THEN [SALE_DATE] = TODAY()
       ENDIF

       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False AND
           (ISBLANK([SALE_TYPE]) = True))
              THEN [SALE_TYPE] = [SALE_TYPE] RECORD 1       
       ENDIF
       
       IF ((ISBLANK([Qty_Sold]) = False AND
           (ISBLANK([Item_No])  = False AND
           (ISBLANK([METHOD]) = True))
              THEN [METHOD] = [METHOD] RECORD 1                             
     ENDSCAN            
ENDPROC